3 USAGE
='[help|start|bad|good|skip|next|reset|visualize|replay|log|run]'
4 LONG_USAGE
='git bisect help
5 print this long help message.
6 git bisect start [<bad> [<good>...]] [--] [<pathspec>...]
7 reset bisect state and start bisection.
9 mark <rev> a known-bad revision.
10 git bisect good [<rev>...]
11 mark <rev>... known-good revisions.
12 git bisect skip [(<rev>|<range>)...]
13 mark <rev>... untestable revisions.
15 find next bisection to test and check it out.
16 git bisect reset [<commit>]
17 finish bisection search and go back to commit.
19 show bisect status in gitk.
20 git bisect replay <logfile>
24 git bisect run <cmd>...
25 use <cmd>... to automatically bisect.
27 Please use "git help bisect" to get the full man page.'
34 _x40
='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
35 _x40
="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
38 test -s "$GIT_DIR/BISECT_START" ||
{
40 gettext "You need to start by \"git bisect start\"" &&
45 echo >&2 -n 'Do you want me to do it for you [Y/n]? '
62 head=$
(GIT_DIR
="$GIT_DIR" git symbolic-ref
-q HEAD
) ||
63 head=$
(GIT_DIR
="$GIT_DIR" git rev-parse
--verify HEAD
) ||
64 die
"$(gettext "Bad HEAD
- I need a HEAD
")"
67 # Check if we are bisecting.
70 if test -s "$GIT_DIR/BISECT_START"
72 # Reset to the rev from where we started.
73 start_head
=$
(cat "$GIT_DIR/BISECT_START")
74 git checkout
"$start_head" -- ||
exit
76 # Get rev from where we start.
79 # This error message should only be triggered by
80 # cogito usage, and cogito users should understand
81 # it relates to cg-seek.
82 [ -s "$GIT_DIR/head-name" ] &&
83 die
"$(gettext "won
't bisect on seeked tree")"
84 start_head="${head#refs/heads/}"
87 die "$(gettext "Bad HEAD - strange symbolic ref")"
93 # Get rid of any old bisect state.
95 bisect_clean_state || exit
98 # Check for one bad and then some good revisions.
102 case "$arg" in --) has_double_dash=1; break ;; esac
104 orig_args=$(git rev-parse --sq-quote "$@")
107 while [ $# -gt 0 ]; do
115 rev=$(git rev-parse -q --verify "$arg^{commit}") || {
116 test $has_double_dash -eq 1 &&
117 die "'$arg' does not appear to be a valid revision"
121 0) state='bad
' ; bad_seen=1 ;;
124 eval="$eval bisect_write '$state' '$rev' 'nolog
'; "
132 # In case of mistaken revs or checkout error, or signals received,
133 # "bisect_auto_next" below may exit or misbehave.
134 # We have to trap this to be able to clean up using
135 # "bisect_clean_state".
137 trap 'bisect_clean_state
' 0
138 trap 'exit 255' 1 2 3 15
141 # Write new start state.
143 echo "$start_head" >"$GIT_DIR/BISECT_START" &&
144 git rev-parse --sq-quote "$@" >"$GIT_DIR/BISECT_NAMES" &&
146 echo "git bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG" || exit
148 # Check if we can proceed to the next bisect state.
161 good|skip) tag="$state"-"$rev" ;;
162 *) die "Bad bisect_write argument: $state" ;;
164 git update-ref "refs/bisect/$tag" "$rev" || exit
165 echo "# $state: $(git show-branch $rev)" >>"$GIT_DIR/BISECT_LOG"
166 test -n "$nolog" || echo "git bisect $state $rev" >>"$GIT_DIR/BISECT_LOG"
170 test -f "$GIT_DIR/BISECT_EXPECTED_REV" &&
171 test "$1" = $(cat "$GIT_DIR/BISECT_EXPECTED_REV")
174 check_expected_revs() {
176 if ! is_expected_rev "$_rev"; then
177 rm -f "$GIT_DIR/BISECT_ANCESTORS_OK"
178 rm -f "$GIT_DIR/BISECT_EXPECTED_REV"
190 revs=$(git rev-list "$arg") || die "Bad rev input: $arg" ;;
192 revs=$(git rev-parse --sq-quote "$arg") ;;
196 eval bisect_state 'skip
' $all
204 die "$(gettext "Please call 'bisect_state
' with at least one argument.")" ;;
206 rev=$(git rev-parse --verify HEAD) ||
207 die "$(gettext "Bad rev input: HEAD")"
208 bisect_write "$state" "$rev"
209 check_expected_revs "$rev" ;;
215 sha=$(git rev-parse --verify "$rev^{commit}") ||
216 die "Bad rev input: $rev"
217 eval="$eval bisect_write '$state' '$sha'; "
220 check_expected_revs "$@" ;;
222 die "$(gettext "'git bisect bad
' can take only one argument.")" ;;
229 bisect_next_check() {
230 missing_good= missing_bad=
231 git show-ref -q --verify refs/bisect/bad || missing_bad=t
232 test -n "$(git for-each-ref "refs/bisect/good-*")" || missing_good=t
234 case "$missing_good,$missing_bad,$1" in
236 : have both good and bad - ok
239 # do not have both but not asked to fail - just report.
243 # have bad but not good. we could bisect although
244 # this is less optimum.
246 gettext "Warning: bisecting only with a bad commit." &&
251 printf >&2 'Are you sure
[Y
/n
]?
'
253 case "$yesno" in [Nn]*) exit 1 ;; esac
255 : bisect without good...
259 test -s "$GIT_DIR/BISECT_START" || {
260 echo >&2 'You need to start by
"git bisect start".
'
263 echo >&2 'You
'$THEN'need to give me
at least one good
' \
264 'and one bad revisions.
'
265 echo >&2 '(You can use
"git bisect bad" and
' \
266 '"git bisect good" for that.
)'
272 bisect_next_check && bisect_next || :
276 case "$#" in 0) ;; *) usage ;; esac
278 bisect_next_check good
280 # Perform all bisection computation, display and checkout
281 git bisect--helper --next-all
284 # Check if we should exit because bisection is finished
285 test $res -eq 10 && exit 0
287 # Check for an error in the bisection process
288 test $res -ne 0 && exit $res
294 bisect_next_check fail
298 if test -n "${DISPLAY+set}${SESSIONNAME+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" &&
299 type gitk >/dev/null 2>&1; then
307 -*) set git log "$@" ;;
312 eval '"$@"' --bisect -- $(cat "$GIT_DIR/BISECT_NAMES")
316 test -s "$GIT_DIR/BISECT_START" || {
317 gettext "We are not bisecting."; echo
321 0) branch=$(cat "$GIT_DIR/BISECT_START") ;;
322 1) git rev-parse --quiet --verify "$1^{commit}" > /dev/null ||
323 die "'$1' is not a valid commit"
328 if git checkout "$branch" -- ; then
331 die "Could not check out original HEAD '$branch'." \
332 "Try 'git bisect
reset <commit
>'."
336 bisect_clean_state() {
337 # There may be some refs packed during bisection.
338 git for-each-ref --format='%(refname
) %(objectname
)' refs/bisect/\* |
341 git update-ref -d $ref $hash || exit
343 rm -f "$GIT_DIR/BISECT_EXPECTED_REV" &&
344 rm -f "$GIT_DIR/BISECT_ANCESTORS_OK" &&
345 rm -f "$GIT_DIR/BISECT_LOG" &&
346 rm -f "$GIT_DIR/BISECT_NAMES" &&
347 rm -f "$GIT_DIR/BISECT_RUN" &&
348 # Cleanup head-name if it got left by an old version of git-bisect
349 rm -f "$GIT_DIR/head-name" &&
351 rm -f "$GIT_DIR/BISECT_START"
355 test "$#" -eq 1 || die "No logfile given"
356 test -r "$1" || die "cannot read $1 for replaying"
358 while read git bisect command rev
360 test "$git $bisect" = "git bisect" -o "$git" = "git-bisect" || continue
361 if test "$git" = "git-bisect"; then
367 cmd="bisect_start $rev"
370 bisect_write "$command" "$rev" ;;
372 die "$(gettext "?? what are you talking about?")" ;;
379 bisect_next_check fail
387 # Check for really bad run error.
388 if [ $res -lt 0 -o $res -ge 128 ]; then
389 echo >&2 "bisect run failed:"
390 echo >&2 "exit code $res from '$@
' is < 0 or >= 128"
394 # Find current state depending on run success or failure.
395 # A special exit code of 125 means cannot test.
396 if [ $res -eq 125 ]; then
398 elif [ $res -gt 0 ]; then
404 # We have to use a subshell because "bisect_state" can exit.
405 ( bisect_state $state > "$GIT_DIR/BISECT_RUN" )
408 cat "$GIT_DIR/BISECT_RUN"
410 if sane_grep "first bad commit could be any of" "$GIT_DIR/BISECT_RUN" \
413 gettext "bisect run cannot continue any more" &&
419 if [ $res -ne 0 ]; then
421 eval_gettext "bisect run failed:
422 'bisect_state \
$state' exited with error code \$res" &&
428 if sane_grep "is the first bad commit" "$GIT_DIR/BISECT_RUN" > /dev/null; then
429 gettext "bisect run success"; echo
437 test -s "$GIT_DIR/BISECT_LOG" || die "$(gettext "We are not bisecting.")"
438 cat "$GIT_DIR/BISECT_LOG"
453 bisect_state "$cmd" "$@" ;;
457 # Not sure we want "next" at the UI level anymore.
460 bisect_visualize "$@" ;;
464 bisect_replay "$@" ;;